#
# spec file for package ghc-data-reify
#
# Copyright (c) 2016 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%global pkg_name data-reify
Name:           ghc-%{pkg_name}
Version:        0.6.1
Release:        1.1
Summary:        Reify a recursive data structure into an explicit graph
License:        BSD-3-Clause
Group:          System/Libraries
Url:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/%{pkg_name}-%{version}.tar.gz
Source1:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/revision/1.cabal
BuildRequires:  ghc-Cabal-devel
# Begin cabal-rpm deps:
BuildRequires:  ghc-containers-devel
BuildRequires:  ghc-rpm-macros
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
# End cabal-rpm deps

%description
'data-reify' provided the ability to turn recursive structures into explicit
graphs. Many (implicitly or explicitly) recursive data structure can be given
this ability, via a type class instance. This gives an alternative to using
'Ref' for observable sharing.

Observable sharing in general is unsafe, so we use the IO monad to bound this
effect, but can be used safely even with 'unsafePerformIO' if some simple
conditions are met. Typically this package will be used to tie the knot with
DSL's that depend of observable sharing, like Lava.

Providing an instance for 'MuRef' is the mechanism for allowing a structure to
be reified into a graph, and several examples of this are provided.

History: Version 0.1 used unsafe pointer compares. Version 0.2 of 'data-reify'
used 'StableName's, and was much faster. Version 0.3 provided two versions of
'MuRef', the mono-typed version, for trees of a single type, and the
dynamic-typed version, for trees of different types. Version 0.4 used 'Int' as
a synonym for 'Unique' rather than 'Data.Unique' for node ids, by popular
demand. Version 0.5 merged the mono-typed and dynamic version again, by using
'DynStableName', an unphantomized version of StableName.

&#169; 2009 Andy Gill; BSD3 license.

%package devel
Summary:        Haskell %{pkg_name} library development files
Group:          Development/Libraries/Other
Requires:       %{name} = %{version}-%{release}
Requires:       ghc-compiler = %{ghc_version}
Requires(post): ghc-compiler = %{ghc_version}
Requires(postun): ghc-compiler = %{ghc_version}

%description devel
This package provides the Haskell %{pkg_name} library development files.

%prep
%setup -q -n %{pkg_name}-%{version}
cp -p %{SOURCE1} %{pkg_name}.cabal


%build
%ghc_lib_build


%install
%ghc_lib_install


%post devel
%ghc_pkg_recache

%postun devel
%ghc_pkg_recache

%files -f %{name}.files
%defattr(-,root,root,-)
%doc LICENSE

%files devel -f %{name}-devel.files
%defattr(-,root,root,-)
%doc CHANGELOG.md README.md

%changelog
* Sun Jul 10 2016 psimons@suse.com
- Update to version 0.6.1 revision 1 with cabal2obs.
